gen_instr MACRO instr, op1, op2, function, instrLabel, base:=<esi+28h>
	LOCAL ep, next, continue
	
IFNB <instrLabel>
instrLabel:
ENDIF
	push eax
	mov eax, [base]
	pushf
	add eax, ($ - function) + (5 + 2 + 2 + (next+2 - ep))
	popf
	jmp eax
ep:
	db 0C7h
	db 44h
	pop eax
IFNB <op2>
	instr op1,op2
ELSE
	instr op1
ENDIF
	push ecx
	mov ecx, [base]
	pushf
	add ecx, ($ - function) + (6 + 2 + 2 + (continue - next + 2))
	popf
	jmp ecx
next:
	db 0C7h
	db 44h
	jmp ep+2
continue:
	db 0C7h
	db 44h
	pop ecx
ENDM

setup_obfuscation MACRO fnStart
	LOCAL dummy
	
	call dummy
dummy:
	pop ebp
	sub ebp, $ - fnStart - 1
	mov [esi+28h], ebp
ENDM
	
gen_instr2 MACRO instr, op1, op2, instrLabel
	LOCAL dummy, dummy2, continue

IFNB <instrLabel>
instrLabel:
ENDIF
	push ecx
	call dummy
	db 0C7h
	db 44h
	pop ecx
IFNB <op2>
	instr op1, op2
ELSE
	IFNB <op1>
		instr op1
	ELSE
		instr
	ENDIF
ENDIF
	push eax
	call dummy2
dummy2:
	pop eax
	pushfd
	dec eax
	add eax, (continue+2) - dummy2
	popfd
	jmp eax
dummy:
	pop ecx
	pushfd
	add ecx, 2
	popfd
	jmp ecx
continue:
	db 35h
	pop eax
ENDM

; calls a function using SEH
seh_call MACRO handler, function, base, retAddr
	push retAddr
	pushad
	mov eax, base
	add eax, handler - real_loader_start
	gen_instr2 push, eax
	gen_instr2 xor, eax, eax
	gen_instr2 push, fs:[eax]
	gen_instr2 mov, fs:[eax], esp
	mov edi, base
	add edi, function - real_loader_start
	push edi
	gen_instr2 cpuid
	gen_instr2 rdtsc
	pop edi
	mov ebx, eax
	xor eax, eax
	idiv eax
ENDM

seh_called MACRO
	pop fs:[0]
	add esp, 4
	popad
ENDM